package org.gcube.social_networking.rest;

import com.webcohesion.enunciate.metadata.rs.RequestHeader;
import com.webcohesion.enunciate.metadata.rs.RequestHeaders;
import com.webcohesion.enunciate.metadata.rs.ResourceGroup;
import com.webcohesion.enunciate.metadata.rs.ResourceLabel;
import org.gcube.social_networking.socialnetworking.model.shared.InviteStatus;
import org.gcube.social_networking.socialnetworking.model.shared.Post;

import javax.ws.rs.*;

@Path("vres")
@ResourceGroup("VREs APIs")
@ResourceLabel("VREs APIs")
@RequestHeaders({
        @RequestHeader( name = "Authorization", description = "Bearer token, see <a href=\"https://dev.d4science.org/how-to-access-resources\">https://dev.d4science.org/how-to-access-resources</a>")
})
public class Vres {
    @POST
    @Path("/{id}/posts")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    @Consumes({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void savePostToVRETimeline(@PathParam("id") String vreid, Post post) {

    }

    @GET
    @Path("/{id}/posts")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getAllPostsByVRE(@PathParam("id") String vreid) {

    }

    @GET
    @Path("/{id}/posts")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getRecentPostsByVRE(@PathParam("id") String vreid, @QueryParam("limit") int limit) {

    }

    @GET
    @Path("/{id}/posts")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getRecentPostsByVREAndRange(@PathParam("id") String vreid, @QueryParam("limit") int limit, @QueryParam("from") int from) {

    }

    @GET
    @Path("/{id}/hashtags")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getVREHashtagsWithOccurrence(@PathParam("id") String vreid) {

    }

    @GET
    @Path("/{id}/hashtags")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getVREHashtagsWithOccurrenceFilteredByTime(@PathParam("id") String vreid, @QueryParam("time") long timestamp) {

    }

    @GET
    @Path("/{id}/hashtags/{hashtag}/posts")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getVREPostsByHashtag(@PathParam("id") String vreid, @PathParam("hashtag") String hashtag) {

    }

    @GET
    @Path("/{id}/email/{email}")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void isExistingInvite(@PathParam("id") String vreid, @PathParam("email") String email) {

    }

    @PUT
    @Path("/{id}/email/{email}")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    @Consumes({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void setInviteStatus(@PathParam("id") String vreid, @PathParam("email") String email, InviteStatus status) {

    }

    @GET
    @Path("/{id}")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    @Consumes({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getInvitedEmailsByVRE(@PathParam("id") String vreid, InviteStatus... status) {

    }

    @GET
    @Path("/")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void getAllVREIds() {

    }
}
